import java.util.Random;

public class GenericDop<T extends EntityTracktor, U extends IDrawningRollers> {

    private T[] Tracktors;
    private U[] Rollers;
    private int maxTracktorAmount;
    private int tracktorAmount;
    private int maxRollersAmount ;
    private int rollersAmount;
    private Random random;
    private int _pictureWidth;
    private int _pictureHeight;
    public GenericDop(int maxTracktorAmount, int maxRollersAmount, int pictureWidth, int pictureHeight){
        this.maxTracktorAmount = maxTracktorAmount;
        this.maxRollersAmount = maxRollersAmount;
        Tracktors = (T[]) new EntityTracktor[maxTracktorAmount];
        Rollers = (U[]) new IDrawningRollers[maxRollersAmount];
        tracktorAmount = 0;
        rollersAmount = 0;
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
        random = new Random();
    }

    public boolean add(T tracktor){
        if (tracktor == null || tracktorAmount > maxTracktorAmount)
            return false;
        Tracktors[tracktorAmount] = tracktor;
        tracktorAmount++;
        return true;
    }

    public boolean add(U roller){
        if (roller == null || rollersAmount > maxRollersAmount)
            return false;
        Rollers[rollersAmount] = roller;
        rollersAmount++;
        return true;
    }

    public DrawningTracktor DrawingTracktorDop(){
        if (tracktorAmount == 0 || rollersAmount == 0)
            return null;
        T tracktor = Tracktors[random.nextInt(tracktorAmount)];
        DrawningTracktor drawingTracktor;
        if (tracktor instanceof EntityExcavator){
            drawingTracktor = new DrawningExcavator((EntityExcavator) tracktor, _pictureWidth, _pictureHeight, random.nextInt(2, 5), Rollers[random.nextInt(rollersAmount)]);
        }
        else{
            drawingTracktor = new DrawningTracktor(tracktor, _pictureWidth, _pictureHeight, random.nextInt(2, 5), Rollers[random.nextInt(rollersAmount)]);
        }
        return drawingTracktor;
    }
}