
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.util.Random;

public class PictureBoxCollection extends JPanel {
    public TracktorsGenericCollection<DrawningTracktor,DrawningObjectExcavator> _traktors;
    private JLabel labelTools;
    private JButton buttonAddTracktor, buttonDeleteTracktor, buttonRefreshCollection, buttonShowDop;
    private JTextField textFieldNumber;
    public PictureBoxCollection() {
        setLayout(null);
        setBounds(0, 0, 800, 450);
        _traktors = new TracktorsGenericCollection<>(this.getWidth() - 200, this.getHeight());
        labelTools = new JLabel("Инструменты");
        labelTools.setBounds(660, 10, 150, 30);
        add(labelTools);
        buttonAddTracktor = new JButton("Добавить экскаватор");
        buttonAddTracktor.setFocusable(false);
        buttonAddTracktor.setBounds(620, 50, 150, 30);
        buttonAddTracktor.addActionListener(e -> {
            FrameExcavator frameExcavator = new FrameExcavator();
            frameExcavator.pictureBoxExcavator.buttonSelectTracktor.addActionListener(e1 -> {
                        if (_traktors.Add(frameExcavator.pictureBoxExcavator.drawingTracktor) != -1) {
                            JOptionPane.showMessageDialog(null, "Объект добавлен", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Не удалось добавить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                        }
                        frameExcavator.dispose();
                        repaint();
                    }
            );
        });
        add(buttonAddTracktor);

        textFieldNumber = new JTextField();
        textFieldNumber.setBounds(620, 100, 150, 30);
        add(textFieldNumber);

        buttonDeleteTracktor = new JButton("Удалить");
        buttonDeleteTracktor.setFocusable(false);
        buttonDeleteTracktor.setBounds(620, 150, 150, 30);
        buttonDeleteTracktor.addActionListener(e -> {
            if (JOptionPane.showConfirmDialog(null, "Удалить объект?", "Удаление", JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
                return;
            }
            for (char it : textFieldNumber.getText().toCharArray())
                if (it < '0' || it > '9') {
                    JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                    return;
                }
            if (textFieldNumber.getText().length() == 0) {
                JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }

            int pos = Integer.parseInt(textFieldNumber.getText());
            if (_traktors.remove(pos)) {
                JOptionPane.showMessageDialog(null, "Объект удален", "Информация", JOptionPane.INFORMATION_MESSAGE);
            } else {
                JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
            }
            repaint();
        });
        add(buttonDeleteTracktor);

        buttonRefreshCollection = new JButton("Обновить коллекцию");
        buttonRefreshCollection.setFocusable(false);
        buttonRefreshCollection.setBounds(620, 200, 150, 30);
        buttonRefreshCollection.addActionListener(e -> repaint());
        add(buttonRefreshCollection);

        buttonShowDop = new JButton("Показать доп");
        buttonShowDop.setFocusable(false);
        buttonShowDop.setBounds(620, 250, 150, 30);
        buttonShowDop.addActionListener(e -> new FrameDop());
        add(buttonShowDop);

        setPreferredSize(new Dimension(800, 450));
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        g2d.drawImage(_traktors.ShowTracktors(), 0, 0, null);
    }
}
