import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.util.Random;

public class PictureBoxExcavator extends JPanel {
    public DrawningTracktor drawingTracktor;

    private AbstractStrategy abstractStrategy;

    private JButton buttonLeft;

    private JButton buttonUp;

    private JButton buttonRight;

    private JButton buttonDown;

    private JButton buttonCreateExcavator;
    private JButton buttonCreateTracktor;
    private JComboBox comboBoxStrategy;
    private JButton buttonStep;
    public JButton buttonSelectTracktor;

    public PictureBoxExcavator() {
        setLayout(null);
        setBounds(0, 0, 800, 450);
        buttonCreateTracktor = new JButton("Создать Трактор");
        buttonCreateTracktor.setFocusable(false);
        buttonCreateTracktor.setBounds(12, 415, 150, 30);
        add(buttonCreateTracktor);

        buttonCreateTracktor.addActionListener(e -> {
            Random random = new Random();
            Color bodyColor = new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256));
            Color selectedColor = JColorChooser.showDialog(this, "Выберите цвет", Color.WHITE);
            if (selectedColor != null)
            {
                bodyColor = selectedColor;
            }
            drawingTracktor = new DrawningTracktor((random.nextInt(200, 300)),
                    random.nextInt(1000, 3000),
                    bodyColor,
                    this.getWidth(), this.getHeight(), random.nextInt(2, 5));
            drawingTracktor.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));
            repaint();
        });

        buttonCreateExcavator = new JButton("Создать экскаватор");
        buttonCreateExcavator.setFocusable(false);
        buttonCreateExcavator.setBounds(180, 415, 150, 30);
        add(buttonCreateExcavator);

        buttonCreateExcavator.addActionListener(e -> {
            Random random = new Random();
            Color bodyColor = new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256));
            Color selectedColor = JColorChooser.showDialog(this, "Выберите цвет", Color.WHITE);
            if (selectedColor != null)
            {
                bodyColor = selectedColor;
            }
            Color bucketColor = new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256));
            selectedColor = JColorChooser.showDialog(this, "Выберите цвет", Color.WHITE);
            if (selectedColor != null)
            {
                bucketColor = selectedColor;
            }
            Color suppotsColor = new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256));
            selectedColor = JColorChooser.showDialog(this, "Выберите цвет", Color.WHITE);
            if (selectedColor != null)
            {
                suppotsColor = selectedColor;
            }

            drawingTracktor = new DrawningExcavator((random.nextInt(200, 300)),
                    random.nextInt(1000, 3000),
                    bodyColor,
                    random.nextBoolean(), true,
                    bucketColor,suppotsColor,
                    this.getWidth(), this.getHeight(), random.nextInt(2, 5));
            drawingTracktor.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));
            repaint();
        });

        buttonSelectTracktor = new JButton("Выбрать");
        buttonSelectTracktor.setFocusable(false);
        buttonSelectTracktor.setBounds(350, 415, 150, 30);
        add(buttonSelectTracktor);

        ActionListener buttonMoveListener = e -> {
            if (drawingTracktor == null)
            {
                return;
            }

            String buttonName = ((JButton) e.getSource()).getName();

            switch (buttonName) {
                case ("buttonUp"):
                    drawingTracktor.MoveTransport(Direction.Up);
                    break;
                case ("buttonDown"):
                    drawingTracktor.MoveTransport(Direction.Down);
                    break;
                case ("buttonLeft"):
                    drawingTracktor.MoveTransport(Direction.Left);
                    break;
                case ("buttonRight"):
                    drawingTracktor.MoveTransport(Direction.Right);
                    break;
            }
            repaint();
        };
        buttonLeft = new JButton();
        buttonLeft.setName("buttonLeft");
        buttonLeft.setFocusable(false);
        buttonLeft.setPreferredSize(new Dimension(30, 30));
        buttonLeft.setIcon(new ImageIcon("Resources/left.png"));
        buttonLeft.addActionListener(buttonMoveListener);
        buttonLeft.setBounds(686, 408, 30, 30);

        add(buttonLeft);

        buttonRight = new JButton();
        buttonRight.setName("buttonRight");
        buttonRight.setFocusable(false);
        buttonRight.setPreferredSize(new Dimension(30, 30));
        buttonRight.setIcon(new ImageIcon("Resources/right.png"));
        buttonRight.addActionListener(buttonMoveListener);
        buttonRight.setBounds(758, 408, 30, 30);

        add(buttonRight);

        buttonDown = new JButton();
        buttonDown.setName("buttonDown");
        buttonDown.setFocusable(false);
        buttonDown.setPreferredSize(new Dimension(30, 30));
        buttonDown.setIcon(new ImageIcon("Resources/down'.png"));
        buttonDown.addActionListener(buttonMoveListener);
        buttonDown.setBounds(722, 408, 30, 30);

        add(buttonDown);

        buttonUp = new JButton();
        buttonUp.setName("buttonUp");
        buttonUp.setFocusable(false);
        buttonUp.setPreferredSize(new Dimension(30, 30));
        buttonUp.setIcon(new ImageIcon("Resources/up.png"));
        buttonUp.addActionListener(buttonMoveListener);
        buttonUp.setBounds(722, 372, 30, 30);

        add(buttonUp);

        String[] items = {
                "0",
                "1"
        };
        comboBoxStrategy = new JComboBox(items);
        comboBoxStrategy.setBounds(667, 10, 120, 25);

        buttonStep = new JButton("Шаг");
        buttonStep.setFocusable(false);
        buttonStep.setBounds(710, 40, 75, 30);

        buttonStep.addActionListener(e -> {
            if (drawingTracktor == null) {
                return;
            }
            if (comboBoxStrategy.isEnabled()) {
                abstractStrategy = switch (comboBoxStrategy.getSelectedIndex()) {
                    case 0 -> new MoveToCenter();
                    case 1 -> new MoveToBorder();
                    default -> null;
                };
                if (abstractStrategy == null)
                {
                    return;
                }
                abstractStrategy.setData(new DrawningObjectExcavator(drawingTracktor), this.getWidth(), this.getHeight());
            }
            if (abstractStrategy == null)
            {
                return;
            }
            comboBoxStrategy.setEnabled(false);
            abstractStrategy.makeStep();
            repaint();
            if (abstractStrategy.getStatus() == Status.Finish)
            {
                comboBoxStrategy.setEnabled(true);
                abstractStrategy = null;
            }
        });

        add(comboBoxStrategy);
        add(buttonStep);
        setPreferredSize(new Dimension(800, 450));
    }

    @Override
    protected void paintComponent(Graphics g) {
        if (drawingTracktor == null) {
            return;
        }
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        drawingTracktor.DrawTransport(g2d);
    }
}
