import java.awt.*;
import java.util.Random;

public enum RollersType {
    Standard,
    Squared,
    Cross;

    public static IDrawningRollers random(int rollersCount, Color bodyColor) {
        return switch (new Random().nextInt(RollersType.values().length)) {
            case 0 -> new DrawningRollers(rollersCount, bodyColor);
            case 1 -> new DrawningSquaredRollers(rollersCount, bodyColor);
            case 2 -> new DrawningCrossRollers(rollersCount, bodyColor);
            default -> null;
        };
    }
}
